PRAGMA foreign_keys = ON;

CREATE TABLE IF NOT EXISTS items(
    id INTEGER PRIMARY KEY NOT NULL,
    type INTEGER NOT NULL,
    data BLOB NOT NULL
);

CREATE TABLE IF NOT EXISTS players(
    id INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL,
    name VARCHAR(100) NOT NULL,
    pass VARCHAR(32) NOT NULL,
    gmail VARCHAR(64) NOT NULL UNIQUE,
    money INTEGER NOT NULL DEFAULT 0,
    avgrecord INTEGER NOT NULL DEFAULT 0,
    record INTEGER NOT NULL DEFAULT 0,
    lastOnline date not null DEFAULT 0,
    onlinetime INTEGER not null DEFAULT 0,
    currentsnake INTEGER DEFAULT NULL,

    FOREIGN KEY(currentsnake) REFERENCES items(id)
        ON UPDATE CASCADE
        ON DELETE SET NULL

);

CREATE TABLE IF NOT EXISTS owners(
    player INTEGER NOT NULL,
    item INTEGER NOT NULL,

    FOREIGN KEY(player) REFERENCES players(id)
        ON UPDATE CASCADE
        ON DELETE CASCADE

    FOREIGN KEY(item) REFERENCES items(id)
        ON UPDATE CASCADE
        ON DELETE CASCADE
);

CREATE UNIQUE INDEX IF NOT EXISTS iowners ON owners(player,item);
